const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const brands = sequelize.define(
    'brands',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

brand_name: {
        type: DataTypes.TEXT,
      
      

      },

website_url: {
        type: DataTypes.TEXT,
      
      

      },

industry: {
        type: DataTypes.TEXT,
      
      

      },

primary_market: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  brands.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






    db.brands.hasMany(db.brand_voice_profiles, {
      as: 'brand_voice_profiles_brand',
      foreignKey: {
          name: 'brandId',
      },
      constraints: false,
    });









    db.brands.hasMany(db.campaigns, {
      as: 'campaigns_brand',
      foreignKey: {
          name: 'brandId',
      },
      constraints: false,
    });

















//end loop





    db.brands.hasMany(db.file, {
      as: 'brand_assets',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.brands.getTableName(),
        belongsToColumn: 'brand_assets',
      },
    });


    db.brands.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.brands.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return brands;
};


